module Kilroy
  module Middleware
    class Visitor
      def initialize(app)
        @app = app
      end

      def call(env)
        request = ActionDispatch::Request.new(env)
        legacy_cookie = request.cookie_jar.permanent.signed[:visitor_id]
        request.cookie_jar.permanent.encrypted[:_kilroy_was_here] ||= { value: { visitor_id: (legacy_cookie || SecureRandom.uuid) } }
        request.cookie_jar.delete(:visitor_id)
        @app.call(env)
      end
    end
  end
end
